/* File: client.cc
 *
 *     This file is part of minkowsky
 *
 *     Copyright (C) 2001-2002 by Rdiger Goetz
 *     Author: Rdiger Goetz <minkowsky@r-goetz.de>
 *
 *     Time-stamp: <27-Oct-2002 18:09:49 goetz>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#define _MINKO_CLIENT_MAIN
#include "client.h"
void initGlobals();

int main(int argc, char *argv[])
{
 char buffer[16384],*p,*t,*s;
 int off=0,ac,i;
 FILE *fp;
 int useTestBin=false;
 char testBinPath[1024];
 char configFile[1024];
 char **args;
 int argAnz;

 initGlobals();

#ifdef MACOSX
 strcpy(configFile,"/Library/Preferences/minkowsky");
 setenv("HOSTTYPE","macintosh",true);
#else
#ifdef WINDOWS
 setenv("HOSTTYPE","windows",true);
 strcpy(configFile,"????/minkowsky");
#else
 strcpy(configFile,"/etc/minkowsky");
#endif
#endif

 // reserve args[0] for 'run' and args[1] for the tcl script
 // reserve some additonal fields in args for internal extra options like -mrr
 argAnz=2;
 args =  new (char *) [argc+8];
 args[0]="run";
 off=0;
 ac=1;

 password[0]='\0';
 username[0]='\0';
 while(ac <argc)
  {
   if(strcmp(argv[ac],"-v")==0)
    {
     fpl= fopen("minko.log","w");
     verbose=true;
    }
   else if (strcmp(argv[ac],"-enableSync")==0)
    {
     enableSync=true;
    }
   else if (strcmp(argv[ac],"-bin")==0)
    {
     useTestBin=true;
     ac++;
     strcpy(testBinPath,argv[ac]);
    }
   else if (strcmp(argv[ac],"-f")==0)
    {
     ac++;
     strcpy(configFile,argv[ac]);
    }
   else if (strcmp(argv[ac],"-u")==0)
    {
     ac++;
     strcpy(username,argv[ac]);
    }
   else if (strcmp(argv[ac],"-p")==0)
    {
     ac++;
     strcpy(password,argv[ac]);
    }
   else if (strcmp(argv[ac],"-F")==0)
    {
     startGUI=false;
     cmdFromFile=true;
     ac++;
     strcpy(cmdFile,argv[ac]);
    }
   else if (strcmp(argv[ac],"-c")==0)
    {
     startGUI=false;
     strcpy(command,"");
     off=argc;
     for(i=ac+1; i<argc; i++)
      {
       strcat(command,argv[i]);
       strcat(command," ");
      }
     break;
    }
   else
    {
     args[argAnz] = new char [strlen(argv[ac])+4];
     strcpy(args[argAnz],argv[ac]);
     argAnz++;

    }
   ac++;
  }

 
 strcpy(binPath,"");
 strcpy(tclBinPath,"");
 strcpy(terminHost,"");

 fp=fopen(configFile,"r");
 if(fp!=NULL)
  {
   p=fgets(buffer,8190,fp);
   while(p!=NULL)
    {
     if(strncmp(buffer,"MINKO_PATH",10)==0)
      {
#     ifdef MACOSX
       char cwd[4096];
       strcpy(binPath,argv[0]);
       t=strstr(binPath,"Contents/MacOS");
       *t='\0';
       strcat(binPath,"Contents/Resources");
#     else
       t=skip2NonWS(buffer+11);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       strcpy(binPath,t);
       sprintf(tclBinPath,"%s/client",t);
#     endif
      }
     else if (strncmp(buffer,"MINKO_SERVER",12)==0)
       {
       t=skip2NonWS(buffer+13);
       s= t+strlen(t)-1;
       if(*s=='\n')
	*s='\0';
       strcpy(terminHost,t);
      }
     else if (strncmp(buffer,"AUTO_INSTALL_MRR",16)==0)
      {
       autoInstallMRR=true;
      }
     else if (strncmp(buffer,"MINKO_AUTO_MRR",14)==0)
      {
       autoInstallMRR=true;
      }
     else if (strncmp(buffer,"ENABLE_SYNC",11)==0)
      {
       enableSync=true;
      }
     p=fgets(buffer,8190,fp);   
    }
  }


 p=getenv("MINKO_PATH");
 if(p==NULL)
   p=getenv("TERMIN_BIN_PATH");

 if(p!=NULL)
  {
   p[strlen(p)-1]='\0';
   t=strrchr(p,'/');
   *t='\0';
  }

 if(p!=NULL)
  if(binPath[0]=='\0')
   {
    strcpy(binPath,p);
    sprintf(tclBinPath,"%s/client",p);
   }

 p=getenv("MINKO_SERVER");
 if(p==NULL)
  p=getenv("TERMIN_HOST");
 
 if(p!=NULL)
  if(terminHost[0]=='\0')
   strcpy(terminHost,p);
 if(terminHost[0]=='\0')
  strcpy(terminHost,"localhost");


 if(useTestBin)
  {
   strcpy(binPath,testBinPath);
   strcpy(tclBinPath,testBinPath);
  }
 
 fclose(fp);


 signal(SIGTERM,closeApp);  
 signal(SIGINT ,closeApp);  


 if(startGUI)
  {
   startTCL(argAnz,args);
  }
}


void initGlobals()
{
 verbose=false;
 for(int i=0;i<8; i++)
  canvasList[i]=NULL;
 
 autoInstallMRR=false;
 enableSync=false;
 startGUI=true;
 cmdFromFile=false;
 fpl=NULL;
#ifdef NO_POLL
 dataAvailable=false;
 timerStopped=false;
#endif
}

char *nextElement(char *t)
{
 char *p;

 while (*t== ' ')
  t++;
 p=strchr(t,' ');
 if(p != NULL)
  *p='\0';
 return(p+1);
}

char *skip2NonWS(char*t)
{
 while(*t==' ' ||*t=='\t')
  t++;
 return(t);
}

char * strTrim (char *t)
{
 char *s,*z;

 s= t+strlen(t)-1;
 while (*s ==' ' || *s=='\n' || *s=='\t')
  s--;
 if(s[1] !='\0' && s>t)
  s[1]='\0';

 s=t;
 while(*s ==' ' || *s=='\n' || *s=='\t')
  s++;
 if(s>t)
  {
   z=t;
   while(*s!='\0')
    {
     *z=*s;
     z++;
     s++;
    }
   // t++;
   *z='\0';
  }
 return(t);
}
