/* File: tcl-unixX11.cc
 *
 *     This file is part of minkowsky
 *
 *     Copyright (C) 2001-2002 by Rdiger Goetz
 *     Author: Rdiger Goetz <minkowsky@r-goetz.de>
 *
 *     Time-stamp: <27-Oct-2002 15:52:18 goetz>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "../client.h"

// Functions in this module used outside the module:
//
// int initApsh(Tcl_Interp *interp)
// int mouseStatus(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])


int initApsh(Tcl_Interp *interp)
{

 if (Tcl_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
 if (Tk_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
 if (Tix_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
 if(!initTclFunctions (interp))
  return TCL_ERROR;

 return TCL_OK;
}


int mouseStatus(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{
 Tk_Window tkwin;
 Display *display;
 Window w;
 Window root_return, child_return;
 int root_x_return, root_y_return;
 int win_x_return, win_y_return;
 unsigned int mask_return;

 tkwin = Tk_NameToWindow(interp,".",Tk_MainWindow(interp)); // Ich kenne noch kein Tk_Window
 w = Tk_WindowId(tkwin);
 display = Tk_Display(tkwin);
 if(XQueryPointer(display, w, &root_return, &child_return,&root_x_return, &root_y_return,&win_x_return, &win_y_return,&mask_return))
  {
   sprintf(interp->result,"%d",mask_return);
  }
 else
  {
   strcpy(interp->result,"-1");
  }
 return TCL_OK;
}

